clc
clear all
r=0.87;
q=0.13;
M=250;
P=19;

%%%%% 1. feladat %%%%%
for turn=1:2 % P=1*P illetve 2*P esetek
    Pi = turn*P; % aktulis P belltsa
    db=0:1:M-1; % szinusz mintaszm vektor
    db=db/M; % szinusz mintaszm vektor normlsa

    s=sin(2*pi*db); % alapharmnikus elksztse
    phase = 2*pi*rand(M/2-1,1); % vltelen kezdfzisuk generlsa a felharmnikusoknak

    for i=2:M/2
        s = s+sin(i*2*pi*db+phase(i-1)); % felharmnikusok generlsa, majd hozzadsa az alapharmnikushoz
    end

    system = tf ([(1-r), 0, 0], [1, 0, 0, r], 1); % modellezend rendszer tviteli fggvnye
    y = lsim (system, s); % szrt mintk

    fprintf('dimW=%dP eset tviteli fggvny egytthati',turn);
    filt_ser=impulse(system,(1:Pi)) % tviteli fggvny egytthati

    top = [0 s(1:end-1)]; % X mtrix els sora
    left = zeros(Pi,1); % X mtrix els oszlopa
    X   = toeplitz(left,top); % X mtrix ellltsa

    R = X*X'; % R mtrix kiszmtsa
    R=R/M; % R mtrix normlsa

    p = X * y; % P mtrix kiszmtsa
    p = p/M; % P mtrix normlsa

    W = R\p; % lineris kombintor slytnyezi, inv(R)*P
       
    fprintf('dimW=%dP eset egytthati',turn);
    W
    
    fprintf('dimW=%dP eset sorfejtett alak s a lineris kombintor egytthatinak eltrse',turn);
    filt_ser(1:Pi)-W
    
    sys = tf([0; W]',1,1,'variable','z^-1'); % modellezett rendszer ellltsa
    ykalap = lsim (sys, s); % becslt mintk generlsa
    
    %%%Diagrammok elksztse
    
    figure(1+turn-1)
    subplot(2,1,1)
    stem((1:Pi), filt_ser(1:Pi))
    hold on
    stem((1:Pi),W,'r')
    hold off
    subplot(2,1,2)
    stem((1:Pi), filt_ser(1:Pi)-W)
    
    figure(3+turn-1)
    subplot(2,1,1)
    stem((-M/2:M/2-1),abs(fft(y)/M))
    hold on
    stem((-M/2:M/2-1),abs(fft(ykalap)/M),'r')
    hold off
    subplot(2,1,2)
    stem((-M/2:M/2-1),abs(fft(y)/M)-abs(fft(ykalap)/M))

    figure(5+turn-1)
    subplot(2,1,1)
    stem(wrapToPi(angle(fft(y)/M)))
    ylim([-pi pi])
    hold on
    stem(wrapToPi(angle(fft(ykalap)/M)),'r')
    ylim([-pi pi])
    hold off
    subplot(2,1,2)
    stem(wrapToPi(wrapToPi(angle(fft(y)/M))-wrapToPi(angle(fft(ykalap)/M))))
    ylim([-pi pi])
end

%%%%%% 2. feladat %%%%%%%

for turn=1:2
    Pi = turn*P;
    db=0:1:M-1;
    db=db/M;

    s=sin(2*pi*db);
    phase = 2*pi*rand(M/2-1,1);

    for i=2:M/2
        s = s+sin(i*2*pi*db+phase(i-1));
    end

    system = tf ([(1-r), 0, 0], [1, 0, 0, r], 1);
    y = lsim (system, s);

    filt_ser=impulse(system,(1:Pi));

    top = [0 s(1:end-1)];
    left = zeros(Pi,1);

    X   = toeplitz(left,top);

    R = X*X';
    R=R/M;

    lambda = max(eig(R)); % lambda az R mtrix sajtrtkeinek maximuma
    LMS_mu = 1/(3000*lambda); % btorsgi tnyez definilsa
    szinusz = s;

    for i=2:M/2
        s = s+sin(i*2*pi*db+phase(i-1));
    end

    for i=1:99
        szinusz = [szinusz s]; % 25000 mintbl ll esemnytr ltrehozsa
    end
    system = tf ([(1-r), 0, 0], [1, 0, 0, r], 1);
    y = lsim (system, szinusz);

    W = zeros(Pi,25000); % kezdeti mtrix nullzsa

    for i=Pi:25000/2
        X=szinusz(i-Pi+1:i); % P darab minta kivtele
        e=y(i)-X*W(:,i);
        W(:,i+1)=W(:,i)+2*LMS_mu*X'*e; % LMS algoritmus szmolsa
    end

    system = tf ([(1-(r-q)), 0, 0], [1, 0, 0, (r-q)], 1); % r q-val val cskkentse
    y = lsim (system, szinusz);

    for i=25000/2+1:25000
        X=szinusz(i-Pi+1:i); % P darab minta kivtele
        e=y(i)-X*W(:,i);
        W(:,i+1)=W(:,i)+2*LMS_mu*X'*e; % LMS algoritmus szmolsa
    end

    fprintf('dimW=%dP eset egytthati, eredeti',turn);
    W(:,25000/2)
    
    fprintf('dimW=%dP eset egytthati, cskkentett r',turn);
    W(:,25000)
    
    figure(7+turn-1)
    [maxW, maxNum] = sort(abs(W(:,end-1)),'descend'); % eremnyek cskken sorrendbe rendezse
    hold all
    for i=1:5
        plot(abs(W(maxNum(i),:)')); % 5 legnagyobb egytthat kirajzolsa
    end
    legend(strcat('W',num2str(maxNum(1:5),-1)))
    hold off
end

%%%%% 3. feladat %%%%%

for turn=1:2
    Pi = turn*P;
    db=0:1:M-1;
    db=db/M;

    s=sin(2*pi*db);
    phase = 2*pi*rand(M/2-1,1);

    for i=2:M/2
        s = s+sin(i*2*pi*db+phase(i-1));
    end

    system = tf ([(1-r), 0, 0], [1, 0, 0, r], 1);
    y = lsim (system, s);

    filt_ser=impulse(system,(1:Pi));

    top = [0 s(1:end-1)];
    left = zeros(Pi,1);

    X   = toeplitz(left,top);

    R = X*X';
    R=R/M;

    lambda = max(eig(R));
    LMS_mu = 1/(10*lambda);
    szinusz = s;

    lambda = 0.9; % feladat lltal megadott paramterek
    v = 0.1;

    for i=2:M/2
        s = s+sin(i*2*pi*db+phase(i-1));
    end

    for i=1:99
        szinusz = [szinusz s]; % 25000 mintbl ll esemnytr ltrehozsa
    end
    system = tf ([(1-r), 0, 0], [1, 0, 0, r], 1);
    y = lsim (system, szinusz);

    W = zeros(Pi,25000);
    R = eye(Pi); % kezdeti mtrixok nullzsa

    for i=Pi:25000/2
        X=szinusz(i-Pi+1:i); % P darab minta kivtele
        num = (R*X'*X*R);
        den = ((lambda/v)+X*R*X');
        R = (1/lambda)*(R-(num/den));
        e=y(i)-X*W(:,i);
        W(:,i+1)=W(:,i)+2*LMS_mu*R*X'*e; % algoritmus szmolsa
    end

    system = tf ([(1-(r-q)), 0, 0], [1, 0, 0, (r-q)], 1); % r q-val val cskkentse
    y = lsim (system, szinusz);

    for i=25000/2+1:25000
        X=szinusz(i-Pi+1:i); % P darab minta kivtele
        num = (R*X'*X*R);
        den = ((lambda/v)+X*R*X');
        R = (1/lambda)*(R-(num/den));
        e=y(i)-X*W(:,i);
        W(:,i+1)=W(:,i)+2*LMS_mu*R*X'*e; % algoritmus szmolsa
    end
    
    fprintf('dimW=%dP eset egytthati, eredeti',turn);
    W(:,25000/2)
    
    fprintf('dimW=%dP eset egytthati, cskkentett r',turn);
    W(:,25000)
    
    figure(9+turn-1)
    [maxW, maxNum] = sort(abs(W(:,end-1)),'descend');
    hold all
    for i=1:5
        plot(abs(W(maxNum(i),:)')); % 5 legnagyobb egytthat kirajzolsa
    end
    legend(strcat('W',num2str(maxNum(1:5),-1)))
    hold off
end

%%%%%% 4. feladat %%%%%%%
P=6; % 6 egytthatt kell keresni

db=0:1:M-1;
db=db/M;

s=sin(2*pi*db);
phase = 2*pi*rand(M/2-1,1);

for i=2:M/2
    s = s+sin(i*2*pi*db+phase(i-1));
end

system = tf ([(1-r), 0, 0], [1, 0, 0, r], 1);
y = lsim (system, s);

filt_ser=impulse(system,(1:P));

top = [0 s(1:end-1)];
left = zeros(P,1);

X = toeplitz(left,top);

R = X*X';
R=R/M;

lambda = max(eig(R));
LMS_mu = 1/(1000*lambda); % btorsgi tnyez meghatrozsa
szinusz = s;

for i=2:M/2
    s = s+sin(i*2*pi*db+phase(i-1));
end

for i=1:99
    szinusz = [szinusz s];
end
system = tf ([(1-r), 0, 0], [1, 0, 0, r], 1);
y = lsim (system, szinusz);

W = zeros(P,25000); % kezdeti mtrix nullzsa

for i=P:25000-1
    X=[szinusz(i-1:i), y(i-3:i)']; % a megadott formula szerint 2 gerjeszt minta,
                                   % valamint 4 kimeneti minta kivlasztsa
    e=y(i+1)-X*W(:,i);
    W(:,i+1)=W(:,i)+2*LMS_mu*X'*e;
end

fprintf('Egytthati:',turn);
W(:,end)

figure(11)
hold all
for i=1:6
	plot(W(i,:)');
end
legend('W0','W1','W2','W3','W4','W5',-1)
plot(W')
